{% extends 'base.html.twig' %}

{% block icon %}fa fa-tachometer{% endblock %}
{% block title %}Tableau de bord de l'administration technique{% endblock %}
{% block breadcrumb %}
    <li>Administration technique</li>
    <li class="active">Tableau de bord de l'administration technique</li>
{% endblock %}

{% block body %}
    {{ include('admin/probe.html.twig') }}

    <section class="container bg-white paginable-section lg-6">
        <header>
            <h4>Etat du disque</h4>
        </header>
        <table id="disk-state" class="table table-striped table-hover"
               data-for="GeneratedDiskState" data-table-uid="0">
            <thead>
            <tr>
                <th title="" data-view="default">Taille</th>
                <th title="" data-view="default">Utilisé</th>
                <th title="" data-view="default">Disponible</th>
                <th title="" data-view="default">Utilisé en %</th>
            </tr>
            </thead>
            <tbody>
            <tr id="table-0-tr-/" data-id="/">
                <td title="" data-view="default">{{ disk.size }}</td>
                <td title="" data-view="default">{{ disk.used }}</td>
                <td title="" data-view="default">{{ disk.avail }}</td>
                <td title="" data-view="default">{{ disk.use }}</td>
            </tr>
            </tbody>
        </table>
    </section>

    <section class="container bg-white paginable-section lg-6">
        <header>
            <h4>Services</h4>
        </header>
        <table id="services-table" class="table table-striped table-hover"
               data-for="GeneratedDiskState" data-table-uid="0">
            <thead>
            <tr>
                <th title="" data-view="default">Service</th>
                <th title="" data-view="default">Informations</th>
                <th class="action" title="" data-view="default">Etat</th>
            </tr>
            </thead>
            <tbody>
            <tr id="table-0-tr-/" data-id="/">
                <td title="" data-view="default">Serveur Mail</td>
                <td title="" data-view="default">{{ dsn_mail }}</td>
                <td class="action" title="" data-view="default">
                    <button type="button" class="btn btn-default" onclick="sendTestMail()">
                        <i class="fa fa-envelope-o" aria-hidden="true"></i>
                        Envoyer un mail de test
                    </button>
                </td>
            </tr>
            <tr>
                <td>Serveur de notifications mercure</td>
                <td>{{ mercure }}</td>
                <td class="h4" id="td-mercure">
                    <i aria-hidden="true"
                       class="fa fa-spinner pull-right fa-spin animated"></i>
                </td>
            </tr>
            </tbody>
        </table>
    </section>

    <section class="container bg-white paginable-section lg-6">
        <header>
            <h4>Échanges avec le client web</h4>
        </header>
        <table class="table table-striped table-hover no-padding">
            <thead>
            <tr>
                <th>Méthodes HTTP</th>
                <th>port</th>
                <th class="text-right">Etat</th>
            </tr>
            </thead>
            <tbody>
            <tr>
                <td>put</td>
                <td>{{ web_port }}</td>
                <td id="td-method-http-put" class="h4">
                    <i aria-hidden="true"
                       class="fa fa-spinner pull-right fa-spin animated"></i>
                </td>
            </tr>
            <tr>
                <td>delete</td>
                <td>{{ web_port }}</td>
                <td id="td-method-http-delete" class="h4">
                    <i aria-hidden="true"
                       class="fa fa-spinner pull-right fa-spin animated"></i>
                </td>
            </tr>
            <tr>
                <td>patch</td>
                <td>{{ web_port }}</td>
                <td id="td-method-http-patch" class="h4">
                    <i aria-hidden="true"
                       class="fa fa-spinner pull-right fa-spin animated"></i>
                </td>
            </tr>
            <tr>
                <td>head</td>
                <td>{{ web_port }}</td>
                <td id="td-method-http-head" class="h4">
                    <i aria-hidden="true"
                       class="fa fa-spinner pull-right fa-spin animated"></i>
                </td>
            </tr>
            </tbody>
        </table>
    </section>
    <script>
        /* globals probeIsRunning */
        const testAjaxMethods = [
            'put', 'delete', 'patch', 'head'
        ];
        for (let i = 0; i < 4; i++) {
            let td = document.getElementById('td-method-http-' + testAjaxMethods[i]);
            fetch('{{ url('admin_test_method') }}', {method: testAjaxMethods[i].toUpperCase()})
                .then(function (response) {
                    if (response.ok) {
                        $(td).html('<i aria-hidden="true" class="fa fa-check-circle pull-right text-success no-margin"></i>');
                    } else {
                        $(td).html('<i aria-hidden="true" class="fa fa-times-circle pull-right text-danger no-margin"></i>');
                    }
                })
                .catch(err =>
                    $(td).html('<i aria-hidden="true" class="fa fa-times-circle pull-right text-danger no-margin"></i>')
                )
            ;
        }
        var checkMercureTime = 0;
        var checkMercureInterval = setInterval(function() {
            let td = document.getElementById('td-mercure');
            if (probeIsRunning) {
                clearInterval(checkMercureInterval);
                $(td).html('<i aria-hidden="true" class="fa fa-check-circle pull-right text-success no-margin"></i>');
            } else {
                checkMercureTime += 500;
                if (checkMercureTime > 2000) {
                    clearInterval(checkMercureInterval);
                    $(td).html('<i aria-hidden="true" class="fa fa-times-circle pull-right text-danger no-margin"></i>')
                }
            }
        }, 500);

        function sendTestMail()
        {
            var email = prompt(
                "Veuillez entrer l'e-mail de destination",
                "{{ app.user.email }}"
            );
            if (email) {
                if (!$('<input type="email">').val(email).is(':valid')) {
                    alert(__("E-mail invalide"));
                    return;
                }
                $.ajax({
                    url: '{{ url('admin_send_test_mail') }}',
                    method: 'POST',
                    data: {
                        email: email
                    },
                    headers: {
                        Accept: 'application/json'
                    },
                    success: function (content, textStatus, jqXHR) {
                        if (content.success) {
                            alert("L'e-mail de test a bien été envoyé");
                        } else {
                            return this.error();
                        }
                    },
                    error: function () {
                        alert("Echec lors de l'envoi de l'e-mail");
                    }
                })
            }
        }
    </script>
{% endblock %}
